-- Auctionator Skin for DecUI, credits to Jasje at http://www.tukui.org/forums/topic.php?id=13159 for original Tukui_Auctionator skin.
-- Dec: Unfortunately unable to resolve skinning issues with unnamed buttons in Auctionator without resorting to this, my Lua-Fu is weak...
-- Dec: Line 545 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Mem_Okay"
-- Dec: Line 663 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Clears_ScanButton"
-- Dec: Line 669 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Clears_PostButton"
-- Dec: Line 675 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Clears_StackButton"
-- Dec: Line 681 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Clears_ShopButton"
-- Dec: Line 720 in AuctionatorConfig.xml rename <Button to <Button name="Atr_Clears_ClearItButton"
-- Dec: Line 793 in AuctionatorConfig.xml rename Atr_ShpList_ImportButton to Atr_ShpList_NewButton
-- Dec: Line 911 in AuctionatorConfig.xml rename <Button to <Button name="Atr_ShpList_CancelBut"
-- Dec: Line 64 in Auctionator.xml rename <Button to <Button name="Atr_Error_Frame_OKAY"

local UI
if ElvUI then UI=ElvUI else UI=Tukui end
local E, C, T, C, L, DB = unpack(UI)

-- Functions needed to make this work
local function SetModifiedBackdrop(self)
	local color = RAID_CLASS_COLORS[T.myclass]
	self:SetBackdropColor(color.r, color.g, color.b, 0.15)
	self:SetBackdropBorderColor(color.r, color.g, color.b)
end

local function SetOriginalBackdrop(self)
	local color = RAID_CLASS_COLORS[T.myclass]
	if C["general"].classcolortheme == true then
		self:SetBackdropBorderColor(color.r, color.g, color.b)
	else
		self:SetTemplate("Default")
	end
end

local function SkinScrollBar(frame)
	if _G[frame:GetName().."BG"] then _G[frame:GetName().."BG"]:SetTexture(nil) end
	if _G[frame:GetName().."Track"] then _G[frame:GetName().."Track"]:SetTexture(nil) end

	if _G[frame:GetName().."Top"] then
		_G[frame:GetName().."Top"]:SetTexture(nil)
		_G[frame:GetName().."Bottom"]:SetTexture(nil)
		_G[frame:GetName().."Middle"]:SetTexture(nil)
	end
end

--Tab Regions
local tabs = {
	"LeftDisabled",
	"MiddleDisabled",
	"RightDisabled",
	"Left",
	"Middle",
	"Right",
}

local function SkinTab(tab)
	if not tab then return end
	for _, object in pairs(tabs) do
		local tex = _G[tab:GetName()..object]
		if tex then
			tex:SetTexture(nil)
		end
	end

	if tab.GetHighlightTexture and tab:GetHighlightTexture() then
		tab:GetHighlightTexture():SetTexture(nil)
	else
		tab:StripTextures()
	end

	tab.backdrop = CreateFrame("Frame", nil, tab)
	tab.backdrop:SetTemplate("Default")
	tab.backdrop:SetFrameLevel(tab:GetFrameLevel() - 1)
	tab.backdrop:Point("TOPLEFT", 10, -3)
	tab.backdrop:Point("BOTTOMRIGHT", -10, 3)
end

local function SkinNextPrevButton(btn, horizonal)
	btn:SetTemplate("Default")
	btn:Size(btn:GetWidth() - 7, btn:GetHeight() - 7)

	if horizonal then
		btn:GetNormalTexture():SetTexCoord(0.3, 0.29, 0.3, 0.72, 0.65, 0.29, 0.65, 0.72)
		btn:GetPushedTexture():SetTexCoord(0.3, 0.35, 0.3, 0.8, 0.65, 0.35, 0.65, 0.8)
		btn:GetDisabledTexture():SetTexCoord(0.3, 0.29, 0.3, 0.75, 0.65, 0.29, 0.65, 0.75)
	else
		btn:GetNormalTexture():SetTexCoord(0.3, 0.29, 0.3, 0.81, 0.65, 0.29, 0.65, 0.81)

		if btn:GetPushedTexture() then
			btn:GetPushedTexture():SetTexCoord(0.3, 0.35, 0.3, 0.81, 0.65, 0.35, 0.65, 0.81)
		end
		if btn:GetDisabledTexture() then
			btn:GetDisabledTexture():SetTexCoord(0.3, 0.29, 0.3, 0.75, 0.65, 0.29, 0.65, 0.75)
		end
	end

	btn:GetNormalTexture():ClearAllPoints()
	btn:GetNormalTexture():Point("TOPLEFT", 2, -2)
	btn:GetNormalTexture():Point("BOTTOMRIGHT", -2, 2)
	if btn:GetDisabledTexture() then
		btn:GetDisabledTexture():SetAllPoints(btn:GetNormalTexture())
	end

	if btn:GetPushedTexture() then
		btn:GetPushedTexture():SetAllPoints(btn:GetNormalTexture())
	end

	btn:GetHighlightTexture():SetTexture(1, 1, 1, 0.3)
	btn:GetHighlightTexture():SetAllPoints(btn:GetNormalTexture())
end

local function SkinRotateButton(btn)
	btn:SetTemplate("Default")
	btn:Size(btn:GetWidth() - 14, btn:GetHeight() - 14)	

	btn:GetNormalTexture():SetTexCoord(0.3, 0.29, 0.3, 0.65, 0.69, 0.29, 0.69, 0.65)
	btn:GetPushedTexture():SetTexCoord(0.3, 0.29, 0.3, 0.65, 0.69, 0.29, 0.69, 0.65)

	btn:GetHighlightTexture():SetTexture(1, 1, 1, 0.3)

	btn:GetNormalTexture():ClearAllPoints()
	btn:GetNormalTexture():Point("TOPLEFT", 2, -2)
	btn:GetNormalTexture():Point("BOTTOMRIGHT", -2, 2)
	btn:GetPushedTexture():SetAllPoints(btn:GetNormalTexture())	
	btn:GetHighlightTexture():SetAllPoints(btn:GetNormalTexture())
end

local function SkinEditBox(frame)
	if _G[frame:GetName().."Left"] then _G[frame:GetName().."Left"]:Kill() end
	if _G[frame:GetName().."Middle"] then _G[frame:GetName().."Middle"]:Kill() end
	if _G[frame:GetName().."Right"] then _G[frame:GetName().."Right"]:Kill() end
	if _G[frame:GetName().."Mid"] then _G[frame:GetName().."Mid"]:Kill() end
	frame:CreateBackdrop("Default")

	if frame:GetName() and frame:GetName():find("Silver") or frame:GetName():find("Copper") then
		frame.backdrop:Point("BOTTOMRIGHT", -12, -2)
	end
end

--Skinning Auctionator
local JasjeAuction = CreateFrame("Frame")
JasjeAuction:RegisterEvent("ADDON_LOADED")
JasjeAuction:SetScript("OnEvent", function(self, event, addon)
if IsAddOnLoaded("Skinner") or IsAddOnLoaded("Aurora") then return end
if not IsAddOnLoaded("Auctionator") then return end

	if addon == "Blizzard_AuctionUI" then
		E.SkinDropDownBox(Atr_Duration)
		E.SkinDropDownBox(Atr_DropDownSL)

		E.SkinButton(Atr_Search_Button, true)
		E.SkinButton(Atr_Back_Button, true)
		E.SkinButton(Atr_Buy1_Button, true)
		E.SkinButton(Atr_Adv_Search_Button, true)
		E.SkinButton(Atr_FullScanButton, true)
		E.SkinButton(Auctionator1Button, true)
		E.SkinButton(Atr_ListTabsTab1, true)
		E.SkinButton(Atr_ListTabsTab2, true)
		E.SkinButton(Atr_ListTabsTab3, true)
		E.SkinButton(Atr_CreateAuctionButton, true)
		E.SkinButton(Atr_RemFromSListButton, true)
		E.SkinButton(Atr_AddToSListButton, true)
		E.SkinButton(Atr_SrchSListButton, true)
		E.SkinButton(Atr_MngSListsButton, true)
		E.SkinButton(Atr_NewSListButton, true)
		E.SkinButton(Atr_CheckActiveButton, true)
		E.SkinButton(AuctionatorCloseButton, true)
		E.SkinButton(Atr_CancelSelectionButton, true)
		E.SkinButton(Atr_FullScanStartButton, true)
		E.SkinButton(Atr_FullScanDone, true)
		E.SkinButton(Atr_CheckActives_Yes_Button, true)
		E.SkinButton(Atr_CheckActives_No_Button, true)
		E.SkinButton(Atr_Adv_Search_ResetBut, true)
		E.SkinButton(Atr_Adv_Search_OKBut, true)
		E.SkinButton(Atr_Adv_Search_CancelBut, true)
		E.SkinButton(Atr_Buy_Confirm_OKBut, true)
		E.SkinButton(Atr_Buy_Confirm_CancelBut, true)
		E.SkinButton(Atr_SaveThisList_Button, true)
		E.SkinButton(Atr_RecommendItem_Tex, true)
		E.SkinButton(Atr_SellControls_Tex, true)

        SkinEditBox(Atr_StackPriceGold)
        SkinEditBox(Atr_StackPriceSilver)
        SkinEditBox(Atr_StackPriceCopper)
        SkinEditBox(Atr_ItemPriceGold)
        SkinEditBox(Atr_ItemPriceSilver)
        SkinEditBox(Atr_ItemPriceCopper)
        SkinEditBox(Atr_Batch_NumAuctions)
        SkinEditBox(Atr_Batch_Stacksize)
        SkinEditBox(Atr_Search_Box)
		SkinEditBox(Atr_AS_Searchtext)
		SkinEditBox(Atr_AS_Minlevel)
		SkinEditBox(Atr_AS_Maxlevel)
		SkinEditBox(Atr_AS_MinItemlevel)
        SkinEditBox(Atr_AS_MaxItemlevel)

		Atr_FullScanResults:StripTextures()
		Atr_FullScanResults:SetTemplate("Transparent")
		Atr_Adv_Search_Dialog:StripTextures()
		Atr_Adv_Search_Dialog:SetTemplate("Transparent")
		Atr_FullScanFrame:StripTextures()
		Atr_FullScanFrame:SetTemplate("Transparent")
		Atr_HeadingsBar:StripTextures()
        Atr_HeadingsBar:SetTemplate("Default")
		Atr_HeadingsBar:Height(246)
		Atr_Error_Frame:StripTextures()
		Atr_Error_Frame:SetTemplate("Transparent")
		Atr_Hlist:StripTextures()
        Atr_Hlist:SetTemplate("Default")
		Atr_Hlist:Width(196)
		Atr_Hlist:ClearAllPoints()
		Atr_Hlist:Point("TOPLEFT", -195, -75)
		Atr_Buy_Confirm_Frame:StripTextures()
		Atr_Buy_Confirm_Frame:SetTemplate("Default")
		Atr_CheckActives_Frame:StripTextures()
        Atr_CheckActives_Frame:SetTemplate("Default")

		-- resize some buttons to fit
		Atr_SrchSListButton:Height(19)
		Atr_SrchSListButton:Width(196)
		Atr_SrchSListButton:ClearAllPoints()
		Atr_SrchSListButton:Point("BOTTOM", Atr_Hlist, 0, -41)
		Atr_MngSListsButton:Height(19)
		Atr_MngSListsButton:Width(196)
		Atr_NewSListButton:Width(196)
		Atr_NewSListButton:Height(19)
		Atr_CheckActiveButton:Width(196)
		Atr_ListTabsTab1:Height(23)
		Atr_ListTabsTab2:Height(23)
		Atr_ListTabsTab3:Height(23)
		Atr_ListTabsTab3:ClearAllPoints()
		Atr_ListTabsTab3:Point("TOPRIGHT", AuctionatorCloseButton, -2, 250)
		Atr_Back_Button:Height(23)
		Atr_Back_Button:ClearAllPoints()
		Atr_Back_Button:Point("LEFT", Atr_ListTabsTab1, -410, 0)
		Atr_AddToSListButton:Height(19)
		Atr_RemFromSListButton:Height(19)
		Atr_AddToSListButton:Width(97)
		Atr_RemFromSListButton:Width(97)
		Atr_RemFromSListButton:ClearAllPoints()
		Atr_RemFromSListButton:Point("RIGHT", Atr_AddToSListButton, 99, 0)

		Atr_CreateAuctionButton:Width(165)
		Atr_CreateAuctionButton:ClearAllPoints()
		Atr_CreateAuctionButton:Point("CENTER", 14, -20)
		Atr_NewSListButton:ClearAllPoints()
		Atr_NewSListButton:Point("BOTTOM", Atr_MngSListsButton, 0, -20)

		Atr_DropDownSL:Width(224)
		Atr_DropDownSL:ClearAllPoints()
		Atr_DropDownSL:Point("TOP", Atr_Hlist, -6, 25)

		Atr_Col1_Heading:ClearAllPoints()
		Atr_Col1_Heading:Point("TOPLEFT", Atr_HeadingsBar, 40, -32)

		Atr_Col3_Heading:ClearAllPoints()
		Atr_Col3_Heading:Point("RIGHT", Atr_Col1_Heading, 105, 1)

		Atr_Col4_Heading:ClearAllPoints()
		Atr_Col4_Heading:Point("RIGHT", Atr_Col3_Heading, 310, 0)

		for i = 1, 6 do
			SkinTab(_G["AuctionFrameTab"..i])
		end

		-- Button Positions
		AuctionatorCloseButton:ClearAllPoints()
		AuctionatorCloseButton:Point("BOTTOMLEFT", Atr_Main_Panel, "BOTTOMRIGHT", -17, 10)
		Atr_Buy1_Button:Point("RIGHT", AuctionatorCloseButton, "LEFT", -5, 0)
		Atr_CancelSelectionButton:Point("RIGHT", Atr_Buy1_Button, "LEFT", -5, 0)
	end

	-- option frames
	Atr_BasicOptionsFrame:StripTextures()
    Atr_BasicOptionsFrame:SetTemplate("Default")
    E.SkinCheckBox(AuctionatorOption_Enable_Alt_CB)
    E.SkinCheckBox(AuctionatorOption_Open_All_Bags_CB)
    E.SkinCheckBox(AuctionatorOption_Show_StartingPrice_CB)
    E.SkinCheckBox(Atr_RB_N)
    E.SkinCheckBox(Atr_RB_M)
    E.SkinCheckBox(Atr_RB_S)
    E.SkinCheckBox(Atr_RB_L)
	
	--Resize Checkboxes
	Atr_RB_N:Size(25, 25)
	Atr_RB_S:Size(25, 25)
	Atr_RB_M:Size(25, 25)
	Atr_RB_L:Size(25, 25)

    Atr_TooltipsOptionsFrame:StripTextures()
    Atr_TooltipsOptionsFrame:SetTemplate("Default")
    E.SkinCheckBox(ATR_tipsVendorOpt_CB)
    E.SkinCheckBox(ATR_tipsAuctionOpt_CB)
    E.SkinCheckBox(ATR_tipsDisenchantOpt_CB)

    Atr_UCConfigFrame:StripTextures()
    Atr_UCConfigFrame:SetTemplate("Default")
	E.SkinButton(Atr_UCConfigFrame_Reset)
	SkinEditBox(Atr_Starting_Discount)

	SkinEditBox(UC_5000000_MoneyInputGold)
	SkinEditBox(UC_5000000_MoneyInputSilver)
	SkinEditBox(UC_5000000_MoneyInputCopper)
	SkinEditBox(UC_1000000_MoneyInputGold)
	SkinEditBox(UC_1000000_MoneyInputSilver)
	SkinEditBox(UC_1000000_MoneyInputCopper)
	SkinEditBox(UC_200000_MoneyInputGold)
	SkinEditBox(UC_200000_MoneyInputSilver)
	SkinEditBox(UC_200000_MoneyInputCopper)
	SkinEditBox(UC_50000_MoneyInputGold)
	SkinEditBox(UC_50000_MoneyInputSilver)
	SkinEditBox(UC_50000_MoneyInputCopper)
	SkinEditBox(UC_10000_MoneyInputGold)
	SkinEditBox(UC_10000_MoneyInputSilver)
	SkinEditBox(UC_10000_MoneyInputCopper)
	SkinEditBox(UC_2000_MoneyInputGold)
	SkinEditBox(UC_2000_MoneyInputSilver)
	SkinEditBox(UC_2000_MoneyInputCopper)
	SkinEditBox(UC_500_MoneyInputGold)
	SkinEditBox(UC_500_MoneyInputSilver)
	SkinEditBox(UC_500_MoneyInputCopper)

    Atr_StackingOptionsFrame:StripTextures()
    Atr_StackingOptionsFrame:SetTemplate("Default")  
	Atr_Stacking_List:StripTextures()
    Atr_Stacking_List:SetTemplate("Default")

	E.SkinButton(Atr_StackingOptionsFrame_Edit)
	E.SkinButton(Atr_StackingOptionsFrame_New)

	Atr_ScanningOptionsFrame:StripTextures()
	Atr_ScanningOptionsFrame:SetTemplate("Default")  

	SkinEditBox(Atr_ScanOpts_MaxHistAge)
	
    AuctionatorResetsFrame:StripTextures()
    AuctionatorResetsFrame:SetTemplate("Default")

	E.SkinButton(Atr_Clears_ScanButton) 
	E.SkinButton(Atr_Clears_PostButton) 
	E.SkinButton(Atr_Clears_StackButton)
	E.SkinButton(Atr_Clears_ShopButton) 

	E.SkinButton(Atr_Clears_ClearItButton) 

	Atr_ShpList_Options_Frame:StripTextures()
    Atr_ShpList_Options_Frame:SetTemplate("Default")
	Atr_ShpList_Frame:StripTextures()
    Atr_ShpList_Frame:SetTemplate("Default")  

	E.SkinButton(Atr_ShpList_DeleteButton)
	E.SkinButton(Atr_ShpList_EditButton)
	E.SkinButton(Atr_ShpList_RenameButton)
	E.SkinButton(Atr_ShpList_ExportButton)
	E.SkinButton(Atr_ShpList_ImportButton) 
	E.SkinButton(Atr_ShpList_NewButton)

	AuctionatorDescriptionFrame:StripTextures()
	AuctionatorDescriptionFrame:SetTemplate("Default")

	Atr_ShpList_Edit_Frame:StripTextures()
	Atr_ShpList_Edit_Frame:SetTemplate("Transparent")

	E.SkinButton(Atr_ShpList_CancelBut)
	E.SkinButton(Atr_ShpList_ImportSaveBut)
	E.SkinButton(Atr_ShpList_SelectAllBut)
	E.SkinButton(Atr_ShpList_SaveBut)
	Atr_ShpList_Edit_FrameScrollFrameScrollBar:StripTextures()
	Atr_ShpList_Edit_FrameScrollFrameScrollBar:SetTemplate("Transparent")
	E.SkinScrollBar(Atr_ShpList_Edit_FrameScrollFrameScrollBar)
	E.SkinScrollBar(Atr_Hlist_ScrollFrameScrollBar)
	E.SkinScrollBar(AuctionatorScrollFrameScrollBar)

	Atr_ConfirmClear_Frame:StripTextures()
	Atr_ConfirmClear_Frame:SetTemplate("Default")

	E.SkinButton(Atr_ClearConfirm_Cancel)

	Atr_MemorizeFrame:StripTextures()
	Atr_MemorizeFrame:SetTemplate("Default")
	
	Atr_Error_Frame:StripTextures()
	Atr_Error_Frame:SetTemplate("Default")	

	E.SkinButton(Atr_Mem_Forget)
	E.SkinButton(Atr_Mem_Cancel)
	E.SkinButton(Atr_Mem_Okay)	
	E.SkinButton(Atr_Error_Frame_OKAY)
	
	E.SkinCheckBox(Atr_Mem_EB_stackSize)

	if addon == "Blizzard_TradeSkillUI" then
		E.SkinButton(Auctionator_Search)
	end
end)