local E, C, L, DB = unpack(select(2, ...)) -- Import Functions/Constants, Config, Locales
if C["skin"].enable ~= true or C["skin"].nonraid ~= true then return end
--I'm sure there's a better way to do this, but I'm a nub, so....
if E.IsPTRVersion() then
local function LoadSkin()
	local StripAllTextures = {
		"RaidParentFrame",
		"RaidParentFrameInset",
		"RaidFinderFrameRoleInset",
		"RaidFinderQueueFrameScrollFrame",
		"RaidFinderQueueFrame",
		"RaidFinderQueueFrameIneligibleFrame",
	}

	local buttons = {
		"RaidFinderFrameFindRaidButton",
		"RaidFinderFrameCancelButton",
        "RaidFrameConvertToRaidButton",
		"RaidFrameRaidInfoButton",
	}

	for _, object in pairs(StripAllTextures) do
		_G[object]:StripTextures()
	end

	for i = 1, #buttons do
		_G[buttons[i]]:StripTextures()
		E.SkinButton(_G[buttons[i]])
	end
	
	RaidParentFrame:SetTemplate("Transparent")
	E.SkinCloseButton(RaidParentFrameCloseButton)
	RaidFinderQueueFrameSelectionDropDown:SetPoint("TOPRIGHT", -4, -112)
	RaidFinderQueueFrameIneligibleFrame:SetTemplate("Default")
	RaidFinderQueueFrameIneligibleFrame:SetBackdropBorderColor(unpack(C.media.backdropcolor))
	
	for i=1, 3 do
		local tab = _G["RaidParentFrameTab"..i]
		if tab then
			E.SkinTab(tab)	
		end
	end
	
	local checkButtons = {
		"RaidFinderQueueFrameRoleButtonTank",
		"RaidFinderQueueFrameRoleButtonHealer",
		"RaidFinderQueueFrameRoleButtonDPS",
		"RaidFinderQueueFrameRoleButtonLeader",
	}

	for _, object in pairs(checkButtons) do
		_G[object].checkButton:SetFrameLevel(_G[object].checkButton:GetFrameLevel() + 2)
		E.SkinCheckBox(_G[object].checkButton)
	end
end

local function LoadRaidSkin()
	local groups = {
		"RaidGroup1",
		"RaidGroup2",
		"RaidGroup3",
		"RaidGroup4",
		"RaidGroup5",
		"RaidGroup6",
		"RaidGroup7",
		"RaidGroup8",
	}

	E.SkinButton(RaidFrameReadyCheckButton)
	for _, object in pairs(groups) do
		_G[object]:StripTextures()
	end
	
	for i=1,8 do
		for j=1,5 do
			_G["RaidGroup"..i.."Slot"..j]:StripTextures()
		end
	end
	
	for i=1,40 do
		_G["RaidGroupButton"..i]:StripTextures()
		_G["RaidGroupButton"..i]:SetTemplate("Transparent")
		_G["RaidGroupButton"..i]:SetBackdropBorderColor(0, 0, 0, 0)
	end
end

tinsert(E.SkinFuncs["ElvUI"], LoadSkin)
E.SkinFuncs["Blizzard_RaidUI"] = LoadRaidSkin
else
local function LoadSkin()
	local StripAllTextures = {
		"RaidInfoFrame",
		"RaidInfoInstanceLabel",
		"RaidInfoIDLabel",
	}

	local KillTextures = {
		"RaidInfoScrollFrameScrollBarBG",
		"RaidInfoScrollFrameScrollBarTop",
		"RaidInfoScrollFrameScrollBarBottom",
		"RaidInfoScrollFrameScrollBarMiddle",
	}
	local buttons = {
		"RaidFrameConvertToRaidButton",
		"RaidFrameRaidInfoButton",
		"RaidFrameNotInRaidRaidBrowserButton",
		"RaidInfoExtendButton",
		"RaidInfoCancelButton",
	}

	for _, object in pairs(StripAllTextures) do
		_G[object]:StripTextures()
	end

	for _, texture in pairs(KillTextures) do
		_G[texture]:Kill()
	end

	for i = 1, #buttons do
		E.SkinButton(_G[buttons[i]])
	end
	RaidInfoScrollFrame:StripTextures()
	RaidInfoFrame:CreateBackdrop("Transparent")
	RaidInfoFrame.backdrop:Point( "TOPLEFT", RaidInfoFrame, "TOPLEFT")
	RaidInfoFrame.backdrop:Point( "BOTTOMRIGHT", RaidInfoFrame, "BOTTOMRIGHT")
	E.SkinCloseButton(RaidInfoCloseButton,RaidInfoFrame)
end

tinsert(E.SkinFuncs["ElvUI"], LoadSkin)
end