local E, C, L, DB = unpack(select(2, ...)) -- Import Functions/Constants, Config, Locales
if C["skin"].enable ~= true or C["skin"].tradeskill ~= true then return end

local function LoadSkin()
	TradeSkillFrame:StripTextures(true)
	TradeSkillListScrollFrame:StripTextures()
	TradeSkillDetailScrollFrame:StripTextures()
	TradeSkillFrameInset:StripTextures()
	TradeSkillExpandButtonFrame:StripTextures()
	TradeSkillDetailScrollChildFrame:StripTextures()
	
	TradeSkillFrameInset:Kill()
	-- TradeSkillFrame:CreateBackdrop("Transparent")
	-- TradeSkillListScrollFrame:CreateBackdrop("Transparent")
	-- TradeSkillDetailScrollFrame:CreateBackdrop("Transparent")
	
	TradeSkillListScrollFrameScrollBar:StripTextures(true)
	TradeSkillDetailScrollFrameScrollBar:StripTextures()
	TradeSkillListScrollFrameScrollBar:CreateBackdrop("Transparent")
	TradeSkillDetailScrollFrameScrollBar:CreateBackdrop("Transparent")
	
	
	TradeSkillFrame:SetTemplate("Transparent")
	TradeSkillFrame:CreateShadow("Default")
	TradeSkillFrame:Height(TradeSkillFrame:GetHeight() + 12)
	TradeSkillRankFrame:StripTextures()
	TradeSkillRankFrame:CreateBackdrop("Default")
	TradeSkillRankFrame:SetStatusBarTexture(C["media"].normTex)
	
	E.SkinButton(TradeSkillCreateButton, true)
	E.SkinButton(TradeSkillCancelButton, true)
	E.SkinButton(TradeSkillFilterButton, true)
	E.SkinButton(TradeSkillCreateAllButton, true)
	E.SkinButton(TradeSkillViewGuildCraftersButton, true)
	
	E.SkinScrollBar(TradeSkillListScrollFrameScrollBar)
	E.SkinScrollBar(TradeSkillDetailScrollFrameScrollBar)
	
	TradeSkillLinkButton:GetNormalTexture():SetTexCoord(0.25, 0.7, 0.37, 0.75)
	TradeSkillLinkButton:GetPushedTexture():SetTexCoord(0.25, 0.7, 0.45, 0.8)
	TradeSkillLinkButton:GetHighlightTexture():Kill()
	TradeSkillLinkButton:CreateBackdrop("Default")
	TradeSkillLinkButton:Size(17, 14)
	TradeSkillLinkButton:Point("LEFT", TradeSkillLinkFrame, "LEFT", 5, -1)
	E.SkinEditBox(TradeSkillFrameSearchBox)
	E.SkinEditBox(TradeSkillInputBox)
	E.SkinNextPrevButton(TradeSkillDecrementButton)
	E.SkinNextPrevButton(TradeSkillIncrementButton)
	TradeSkillIncrementButton:Point("RIGHT", TradeSkillCreateButton, "LEFT", -13, 0)
	
	E.SkinCloseButton(TradeSkillFrameCloseButton)
	
	--[[
This addon adds a filter possibility to the Tradeskill window.
Author: Michel van de Wetering
This will only show recipes that have a chance to give a skillup. This makes it easier 
to find  those recipies that will inprove your Tradeskill level, but are lower in the list.
]]--

-- Language stuff
local CRAFT_SKILLUPS_ONLY_TOOLTIP = "Only show recipes that have a chance to increase your skill."

-- Create a new button
local but = CreateFrame("CheckButton", "TradeSkillIncreaseFilterButton", TradeSkillFrame, "UICheckButtonTemplate")

-- Setup sizes and textures
but:SetWidth(21)
but:SetHeight(21)
but:SetNormalTexture("Interface\\Addons\\ElvUI\\media\\textures\\Button-OnlySkillups-Disabled")
but:SetPushedTexture("Interface\\Addons\\ElvUI\\media\\textures\\Button-OnlySkillups-Enabled")
but:SetCheckedTexture("Interface\\Addons\\ElvUI\\media\\textures\\Button-OnlySkillups-Enabled")

-- Click handling (just toggle setting based on current setting)
but:SetScript("OnClick",function(self,button)
	TradeSkillOnlyShowSkillUps(self:GetChecked())
end)

-- Tooltip handling
but:SetScript("OnEnter",function(self)
	GameTooltip:SetOwner(self, "ANCHOR_LEFT")
	GameTooltip:SetText(CRAFT_SKILLUPS_ONLY_TOOLTIP, nil, nil, nil, nil, 1)
end)
but:SetScript("OnLeave",function(self)
	GameTooltip:Hide()
end)

-- Put button the place where the "Have materials" checkbox is now
but:ClearAllPoints()
but:SetPoint("TOPLEFT", TradeSkillFrame , "TOPLEFT", 42, -30)

-- Initial setting, just to make sure all is in sync
TradeSkillOnlyShowSkillUps(but:GetChecked())

-- ------
--  TinyWideTradeSkills by Ameya Selen, a.k.a. Amenity (Andorhal_US)
--	http://www.curseforge.com/profiles/ameyaselene/
--  This addon is a fan remake of popular tradeskill frame-widening addons such as DoubleWideTradeSkills and DoubleWideProfessions.
--  As such it borrows heavily from both addons, I claim no credit for the code contained herein, and release it into the public domain.
-- ------

TradeSkillFrame:SetAttribute("UIPanelLayout-width", 675)

TradeSkillFrame:SetWidth(675)
TradeSkillFrame:SetHeight(436)

TRADE_SKILLS_DISPLAYED = 19

CreateFrame("Button", "TradeSkillSkill9", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill8, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill10", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill9, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill11", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill10, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill12", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill11, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill13", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill12, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill14", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill13, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill15", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill14, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill16", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill15, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill17", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill16, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill18", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill17, "BOTTOMLEFT")
CreateFrame("Button", "TradeSkillSkill19", TradeSkillFrame, "TradeSkillSkillButtonTemplate"):SetPoint("TOPLEFT", TradeSkillSkill18, "BOTTOMLEFT")

TradeSkillSkill1:ClearAllPoints()
TradeSkillSkill1:SetPoint("TOPLEFT", 22, -100)
TradeSkillListScrollFrame:ClearAllPoints()
TradeSkillListScrollFrame:SetPoint("TOPLEFT", 22, -96)
TradeSkillListScrollFrame:SetHeight(310)

TradeSkillDetailScrollFrame:ClearAllPoints();
TradeSkillDetailScrollFrame:SetPoint("TOPLEFT", TradeSkillListScrollFrame, "TOPRIGHT", 35, -2)
TradeSkillDetailScrollFrame:SetWidth(298)
TradeSkillDetailScrollFrame:SetHeight(310)

TradeSkillInputBox:ClearAllPoints();
TradeSkillInputBox:SetPoint("TOPRIGHT", TradeSkillIncrementButton, "TOPLEFT", 0, 0)
TradeSkillInputBox:SetJustifyH("RIGHT")
TradeSkillInputBox:SetTextInsets(0,4,2,0)

TradeSkillDecrementButton:ClearAllPoints();
TradeSkillDecrementButton:SetPoint("TOPRIGHT", TradeSkillInputBox, "TOPLEFT", -4, 0)

TradeSkillCreateAllButton:ClearAllPoints();
TradeSkillCreateAllButton:SetPoint("TOPRIGHT", TradeSkillDecrementButton, "TOPLEFT", 0, 0)


local function CreateTex(parent, tex, layer, width, height, ...)
	local texf = parent:CreateTexture(nil, layer)
	texf:SetPoint(...)
	texf:SetTexture(tex)
	texf:SetWidth(width); texf:SetHeight(height)
	return texf
end

CreateTex(TradeSkillListScrollFrame, [[Interface\ClassTrainerFrame\UI-ClassTrainer-ScrollBar]], "BACKGROUND", 30, 97.4, "LEFT", TradeSkillListScrollFrame, "RIGHT", -3, 0):SetTexCoord(0, 0.46875, 0.2, 0.9609375)

for i, region in ipairs({TradeSkillFrame:GetRegions()}) do
	if region:IsObjectType("Texture") then
		if region:GetTexture() == [[Interface\ClassTrainerFrame\UI-ClassTrainer-HorizontalBar]] then
			region:Hide()
		end
	end
end
	
	local once = false
	hooksecurefunc("TradeSkillFrame_SetSelection", function(id)
		TradeSkillSkillIcon:StyleButton()
		if TradeSkillSkillIcon:GetNormalTexture() then
			TradeSkillSkillIcon:GetNormalTexture():SetTexCoord(.08, .92, .08, .92)
			TradeSkillSkillIcon:GetNormalTexture():ClearAllPoints()
			TradeSkillSkillIcon:GetNormalTexture():Point("TOPLEFT", 2, -2)
			TradeSkillSkillIcon:GetNormalTexture():Point("BOTTOMRIGHT", -2, 2)
		end
		TradeSkillSkillIcon:SetTemplate("Default")

		for i=1, MAX_TRADE_SKILL_REAGENTS do
			local button = _G["TradeSkillReagent"..i]
			local icon = _G["TradeSkillReagent"..i.."IconTexture"]
			local count = _G["TradeSkillReagent"..i.."Count"]
			
			icon:SetTexCoord(.08, .92, .08, .92)
			icon:SetDrawLayer("OVERLAY")
			if not icon.backdrop then
				icon.backdrop = CreateFrame("Frame", nil, button)
				icon.backdrop:SetFrameLevel(button:GetFrameLevel() - 1)
				icon.backdrop:SetTemplate("Default")
				icon.backdrop:Point("TOPLEFT", icon, "TOPLEFT", -2, 2)
				icon.backdrop:Point("BOTTOMRIGHT", icon, "BOTTOMRIGHT", 2, -2)
			end
			
			icon:SetParent(icon.backdrop)
			count:SetParent(icon.backdrop)
			count:SetDrawLayer("OVERLAY")
			
			if i > 2 and once == false then
				local point, anchoredto, point2, x, y = button:GetPoint()
				button:ClearAllPoints()
				button:Point(point, anchoredto, point2, x, y - 3)
				once = true
			end
			
			_G["TradeSkillReagent"..i.."NameFrame"]:Kill()
		end
	end)
	
	
	--Guild Crafters
	TradeSkillGuildFrame:StripTextures()
	TradeSkillGuildFrame:SetTemplate("Transparent")
	TradeSkillGuildFrame:Point("BOTTOMLEFT", TradeSkillFrame, "BOTTOMRIGHT", 3, 19)
	TradeSkillGuildFrameContainer:StripTextures()
	TradeSkillGuildFrameContainer:SetTemplate("Default")
	E.SkinScrollBar(TradeSkillGuildCraftersFrameScrollBar)
	E.SkinCloseButton(TradeSkillGuildFrameCloseButton)
end

E.SkinFuncs["Blizzard_TradeSkillUI"] = LoadSkin