local function initialize()
	local l_GuildBankTab_OnClick = GuildBankTab_OnClick

	function GuildBankTab_OnClick(self, ...)
		-- because this is a CheckButton, it will return nil if it was previously selected and clicked, as we want it 
		if not self:GetChecked() and IsGuildLeader() then
			local type, id = GetCursorInfo()
			
			if type == "item" then
                -- Load icon texture and delete the path up to the slash
				local _, _, _, _, _, _, _, _, _, texture = GetItemInfo(id)
                texture = texture:gsub('.*\\', '')
				
                -- Get other settings
				local tab = self:GetParent():GetID()
				local name, icon = GetGuildBankTabInfo(tab)

				-- Apply all settings
				SetGuildBankTabInfo(tab, name, texture)
				ClearCursor()
			end
		end
		
		return l_GuildBankTab_OnClick(self, ...)
	end
end

local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", function(self, event, addon)
	if (addon == "Blizzard_GuildBankUI") then
		-- print("Loaded gbank")
		initialize()
	end
end)
