﻿
-- --------------------------
-- Improved PvP Frame
-- By Cybeloras of Mal'Ganis
-- --------------------------

BG_BUTTON_SCROLL_WIDTH = BG_BUTTON_WIDTH

local PVPWORLD_DESCRIPTIONS = {} -- Dear Blizzard, Why isn't this global?
PVPWORLD_DESCRIPTIONS[1] = WINTERGRASP_DESCRIPTION
PVPWORLD_DESCRIPTIONS[21] = TOL_BARAD_DESCRIPTION


local function PVPHonor_ButtonClicked(self)
	--i literally burst into laughter when i saw the original blizzard code for this function. i guess that makes me a super geek?
	local id = self:GetID()
	for i= 1, NUM_DISPLAYED_BATTLEGROUNDS do
		if id == i then
			_G["PVPHonorFrameBgButton"..i]:LockHighlight()
		else
			_G["PVPHonorFrameBgButton"..i]:UnlockHighlight()
		end
	end
	
	self:GetParent().selectedButtonIndex = id
	self:GetParent().selectedIsWorldPvp = self.isWorldPVP
	self:GetParent().selectedPvpID = self.pvpID
	PVPHonorFrame_ResetInfo()
	PVPHonorFrame_UpdateGroupAvailable()
end


local originalNum = NUM_DISPLAYED_BATTLEGROUNDS
local p, _, r, x, y = PVPHonorFrameBgButton2:GetPoint()

for i = NUM_DISPLAYED_BATTLEGROUNDS+1, GetNumWorldPVPAreas() + GetNumBattlegroundTypes() do
	local f = CreateFrame("Button", "PVPHonorFrameBgButton" .. i, PVPHonorFrame, "PVPBattlegroundButtonTemplate", i)
	f:SetPoint(p, _G["PVPHonorFrameBgButton" .. i-1], r, x, y)
	NUM_DISPLAYED_BATTLEGROUNDS = i
end

local function OnEnter(self)
	local f = self:GetParent()
	
	local title, text, _, isHoliday, isRandom
	if f.isWorldPVP then
		title = f.localizedName
		text = PVPWORLD_DESCRIPTIONS[GetWorldPVPAreaInfo(f.pvpID)]
		if not text or text == "" then
			text = "Missing Map Description"
		end
	elseif f.pvpID then
		title, _, isHoliday, isRandom, _, text = GetBattlegroundInfo(f.pvpID)
		if isRandom then
			text = RANDOM_BATTLEGROUND_EXPLANATION
		elseif isHoliday then
			text = BATTLEGROUND_HOLIDAY_EXPLANATION .. "\r\n\r\n\r\n" .. text
		end
	end
	text = text and ("\r\n" .. strtrim(text, " \r\n"))
	
	GameTooltip_SetDefaultAnchor(GameTooltip, self)
	GameTooltip:AddLine(title, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, 1)
	GameTooltip:AddLine(text, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1)
	GameTooltip:Show()
end

local function OnLeave(self)
	GameTooltip:Hide()
end
for i = 1, NUM_DISPLAYED_BATTLEGROUNDS do
	local f = _G["PVPHonorFrameBgButton" .. i]
	f:SetScript("OnClick",  PVPHonor_ButtonClicked)
	f.IPF_infoButton = CreateFrame("Button", f:GetName() .. "InfoButton", f, "UIPanelInfoButton")
	f.IPF_infoButton:SetPoint("RIGHT")
	f.IPF_infoButton:SetScript("OnEnter", OnEnter)
	f.IPF_infoButton:SetScript("OnLeave", OnLeave)
	f:SetFrameLevel(f:GetParent():GetFrameLevel()+1)
	f.IPF_infoButton:SetFrameLevel(f:GetFrameLevel()+1)
end

PVPHonor_UpdateBattlegrounds()

PVPHonorFrameInfoScrollFrameChildFrameRewardsInfoTitle:Hide()
PVPHonorFrameInfoScrollFrameChildFrameRewardsInfoDescription:Hide()
PVPHonorFrameInfoScrollFrameChildFrameDescription:Hide()
PVPHonorFrameInfoScrollFrameChildFrameDescription.Show = function() end

PVPHonorFrameBGTex:SetPoint("TOP", 0, -92 - ((NUM_DISPLAYED_BATTLEGROUNDS - originalNum)*PVPHonorFrameBgButton1:GetHeight()))

PVPHonorFrameInfoScrollFrameChildFrameRewardsInfoRewardsLabel:ClearAllPoints()
PVPHonorFrameInfoScrollFrameChildFrameRewardsInfoRewardsLabel:SetPoint("TOPLEFT", PVPHonorFrameBGTex, "TOPLEFT", 25.5, -15)

PVPHonorFrameInfoScrollFrameScrollBar:Hide()
PVPHonorFrameInfoScrollFrameScrollBar.Show = function() end