--[[
Farmbuyer, Kilrogg realm
farmbuyer@gmail.com
]]

--[[
QLC_debug = {}
QQQ = function()
 print("QLC_debug:")
 for _,x in ipairs(QLC_debug) do
  print("  header:  "..x)
 end
 print("done")
end
--]]


local frame = CreateFrame("Frame")

frame:SetScript("OnEvent", function(self,event)
	local GetQuestLogTitle = _G.GetQuestLogTitle
	local i

	if event == "QUEST_LOG_UPDATE" then
		--print("QUEST_LOG_UPDATE fired, fixup")
		QuestLogCollapseList = QuestLogCollapseList or {}

		i = 1
		while GetQuestLogTitle(i) ~= nil do
			local header_p = select(5, GetQuestLogTitle(i))
			if header_p and QuestLogCollapseList[i] then
				--table.insert(QLC_debug,i)
				CollapseQuestHeader(i)
			end
			i = i + 1
		end

		-- Only need to do the fixup once.
		self:UnregisterEvent("QUEST_LOG_UPDATE")

	elseif event == "PLAYER_LOGIN" then
		-- Can't do fixup here; sometimes the quest log information
		-- isn't available yet!  Maybe under high latency, etc.  Safer
		-- to register for quest updates, which will fire almost as soon
		-- as the player sees the playfield.
		self:RegisterEvent("QUEST_LOG_UPDATE")

	elseif event == "PLAYER_LOGOUT" then
		QuestLogCollapseList = {}

		i = 1
		while GetQuestLogTitle(i) ~= nil do
			local header_p, collapsed_p = select(5, GetQuestLogTitle(i))
			if header_p and collapsed_p then
				QuestLogCollapseList[i] = true
			end
			i = i + 1
		end
	end
end)

frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PLAYER_LOGOUT")

