local E, C, L, DB = unpack(select(2, ...)) -- Import Functions/Constants, Config, Locales
---------------------------------------------------------------------------------------------------------------------------------
-- tekKompare by Tekkub found at http://www.wowinterface.com/downloads/info6837-tekKompare.html
-- only used Hoverlinks
---------------------------------------------------------------------------------------------------------------------------------
local orig1, orig2 = {}, {}
local GameTooltip = GameTooltip

local linktypes = {item = true, enchant = true, spell = true, quest = true, unit = true, talent = true, achievement = true, glyph = true, instancelock = true}

local function OnHyperlinkEnter(frame, link, ...)
	local linktype = link:match("^([^:]+)")
	if linktype and linktypes[linktype] then
		GameTooltip:SetOwner(frame, "ANCHOR_TOPLEFT")
		GameTooltip:SetHyperlink(link)
		GameTooltip:Show()
	end

	if orig1[frame] then return orig1[frame](frame, link, ...) end
end

local function OnHyperlinkLeave(frame, ...)
	GameTooltip:Hide()
	if orig2[frame] then return orig2[frame](frame, ...) end
end


local _G = getfenv(0)
for i=1, NUM_CHAT_WINDOWS do
	local frame = _G["ChatFrame"..i]
	orig1[frame] = frame:GetScript("OnHyperlinkEnter")
	frame:SetScript("OnHyperlinkEnter", OnHyperlinkEnter)

	orig2[frame] = frame:GetScript("OnHyperlinkLeave")
	frame:SetScript("OnHyperlinkLeave", OnHyperlinkLeave)
end

--[[
LightMyMacro - Enable glowing overlays on macros.
Copyright 2010 Adirelle (adirelle@tagada-team.net)
All rights reserved.
--]]

local ActionButton_ShowOverlayGlow = ActionButton_ShowOverlayGlow
local ActionButton_HideOverlayGlow =ActionButton_HideOverlayGlow
local ActionButton_UpdateOverlayGlow = ActionButton_UpdateOverlayGlow
local GetActionInfo = GetActionInfo
local GetMacroSpell = GetMacroSpell

local overlayedSpells = {}

hooksecurefunc('ActionButton_HideOverlayGlow', function(button)
	if button.__LAB_Version then return end
	local actionType, actionParam = GetActionInfo(button.action)
	if actionType == "macro" and overlayedSpells[GetMacroSpell(actionParam) or false] then
		return ActionButton_ShowOverlayGlow(button)
	end
end)

hooksecurefunc('ActionButton_OnEvent',  function(button, event, id)
	if event == 'SPELL_ACTIVATION_OVERLAY_GLOW_SHOW' or event == 'SPELL_ACTIVATION_OVERLAY_GLOW_HIDE' then
		local spell, actionType, actionParam = GetSpellInfo(id), GetActionInfo(button.action)
		local show = event == "SPELL_ACTIVATION_OVERLAY_GLOW_SHOW"
		overlayedSpells[spell] = show
		if actionType == 'macro' and GetMacroSpell(actionParam) == spell then
			if show then
				return ActionButton_ShowOverlayGlow(button)
			else
				return ActionButton_HideOverlayGlow(button)
			end
		end
	end
end);

---------------------------------------------------------------------------------------------------------------------------------
-- Align by Akeru found at http://www.wowinterface.com/downloads/info6153-Align.html
---------------------------------------------------------------------------------------------------------------------------------
local grid
local boxSize = 32

function Grid_Show()
	if not grid then
        Grid_Create()
	elseif grid.boxSize ~= boxSize then
        grid:Hide()
        Grid_Create()
    else
		grid:Show()
	end
end

function Grid_Hide()
	if grid then
		grid:Hide()
	end
end

local isAligning = false
SLASH_TOGGLEGRID1 = "/align"
SlashCmdList["TOGGLEGRID"] = function(arg)
    if isAligning then
        Grid_Hide()
        isAligning = false
    else
        boxSize = (math.ceil((tonumber(arg) or boxSize) / 32) * 32)
    if boxSize > 256 then boxSize = 256 end    
        Grid_Show()
        isAligning = true
    end
end

function Grid_Create() 
	grid = CreateFrame('Frame', nil, UIParent) 
	grid.boxSize = boxSize 
	grid:SetAllPoints(UIParent) 

	local size = 2 
	local width = GetScreenWidth()
	local ratio = width / GetScreenHeight()
	local height = GetScreenHeight() * ratio

	local wStep = width / boxSize
	local hStep = height / boxSize

	for i = 0, boxSize do 
		local tx = grid:CreateTexture(nil, 'BACKGROUND') 
		if i == boxSize / 2 then 
			tx:SetTexture(1, 0, 0, 0.5) 
		else 
			tx:SetTexture(0, 0, 0, 0.5) 
		end 
		tx:SetPoint("TOPLEFT", grid, "TOPLEFT", i*wStep - (size/2), 0) 
		tx:SetPoint('BOTTOMRIGHT', grid, 'BOTTOMLEFT', i*wStep + (size/2), 0) 
	end 
	height = GetScreenHeight()
	
	do
		local tx = grid:CreateTexture(nil, 'BACKGROUND') 
		tx:SetTexture(1, 0, 0, 0.5)
		tx:SetPoint("TOPLEFT", grid, "TOPLEFT", 0, -(height/2) + (size/2))
		tx:SetPoint('BOTTOMRIGHT', grid, 'TOPRIGHT', 0, -(height/2 + size/2))
	end
	
	for i = 1, math.floor((height/2)/hStep) do
		local tx = grid:CreateTexture(nil, 'BACKGROUND') 
		tx:SetTexture(0, 0, 0, 0.5)
		
		tx:SetPoint("TOPLEFT", grid, "TOPLEFT", 0, -(height/2+i*hStep) + (size/2))
		tx:SetPoint('BOTTOMRIGHT', grid, 'TOPRIGHT', 0, -(height/2+i*hStep + size/2))
		
		tx = grid:CreateTexture(nil, 'BACKGROUND') 
		tx:SetTexture(0, 0, 0, 0.5)
		
		tx:SetPoint("TOPLEFT", grid, "TOPLEFT", 0, -(height/2-i*hStep) + (size/2))
		tx:SetPoint('BOTTOMRIGHT', grid, 'TOPRIGHT', 0, -(height/2-i*hStep + size/2))
		
	end
	
end

-- RealTime by Liu - Display actual duration on buffs rather than the xh or xm durations shown by the default UI
-- Simply hook the function Blizzard uses to abbreviate times and return a sane value

function SecondsToTimeAbbrev(time)
	-- Nothing is nothing
	if time <= 0 then
		return "";
	end
	if time < 60 then
		-- display anything < 1m as xs
		return string.format("%ds", time);
	end
	if time < 3600 then
		-- display < 1h as mm:ss
		return string.format("%d:%02d", time / 60, time % 60);
	end
	-- display anything over an hour in hh:mmh format (eg. 2:43h)
	return string.format("%d:%02dh", time / 3600, (time % 3600) / 60 );
end

-- ICWutUDidThere by Shefki http://www.wowinterface.com/downloads/info13068-ICWutUDidThere.html
local _G = getfenv(0)
local UnitAura = _G.UnitAura
local UnitName = _G.UnitName
local strformat = _G.string.format
local strsub = _G.string.sub

local TOOLTIP_TEXT = "Applied by %s"
local PET_TEXT = "%s <%s>"

local function SetUnitAura(tooltip, unit, id, filter)
	local _, _, _, _, _, _, _, caster = UnitAura(unit, id, filter)
	if caster then
		local display_name
		if caster == "vehicle" or caster == "pet" then
			display_name = strformat(PET_TEXT, UnitName(caster), UnitName("player"))
		elseif strsub(caster, 1, 8) == "partypet" and strsub(caster, -6) ~= "target" then
			local party_id = strsub(caster, 9)
			display_name = strformat(PET_TEXT, UnitName(caster), UnitName("party"..party_id))
		elseif strsub(caster, 1, 7) == "raidpet" and strsub(caster, -6) ~= "target" then
			local raid_id = strsub(caster, 8)
			display_name = strformat(PET_TEXT, UnitName(caster), UnitName("raid"..raid_id))
		else
			display_name = UnitName(caster)
		end

		tooltip:AddLine(strformat(TOOLTIP_TEXT,display_name))
		tooltip:Show()
	end
end

local function SetUnitBuff(tooltip, unit, id, filter)
	SetUnitAura(tooltip, unit, id, "HELPFUL "..(filter or ""))
end

local function SetUnitDebuff(tooltip, unit, id, filter)
	SetUnitAura(tooltip, unit, id, "HARMFUL "..(filter or ""))
end

hooksecurefunc(GameTooltip, "SetUnitAura", SetUnitAura)
hooksecurefunc(GameTooltip, "SetUnitBuff", SetUnitBuff)
hooksecurefunc(GameTooltip, "SetUnitDebuff", SetUnitDebuff)

-- AFKFix by Kaustos http://www.wowinterface.com/downloads/info20904-AFKFix.html
local frame = CreateFrame("Frame", "AFK Auto-fix")
frame:SetScript("OnEvent", function(self, event, ...) self[event](self, event, ...) end)
function frame:PLAYER_ENTERING_WORLD() if UnitIsAFK("player") then SendChatMessage("","AFK") end end
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

--[[-------------------------------------------------------------------------
	DontSoloQueue http://www.wowinterface.com/downloads/info19705-DontSoloQueue.html
	Please contact Morsker through PM on wowace.com.

	Copyright (c) 2011  Morsker

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in
	all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	THE SOFTWARE.
---------------------------------------------------------------------------]]

local CreateFrame = CreateFrame
local GetNumPartyMembers = GetNumPartyMembers
local GetNumRaidMembers = GetNumRaidMembers
local IsAltKeyDown = IsAltKeyDown
local PVPFrame = PVPFrame
local PVPFrameLeftButton = PVPFrameLeftButton

local frame
local altKeyWasDown

-- The central hook that's reached in several ways:
-- 1. Once when the addon loads.
-- 2. When PVPFrame changes its selected tab.
-- 3. On events that might involve joining / leaving party.
-- 4. On Alt key press / release.
--
-- Because this is generic, it doesn't make assumptions, and checks everything relevant.
-- It's called so rarely that optimization would be a mistake.
local function FixSoloQueueButton()
	if PVPFrame:IsShown() and PVPFrame.selectedTab == 1 then
		if IsAltKeyDown() or (GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0) then
			PVPFrameLeftButton:Enable()
		else
			PVPFrameLeftButton:Disable()
		end
	end
end

-- Watch for Alt key press / release.
local function CheckAltOnUpdate()
	if altKeyWasDown ~= IsAltKeyDown() then
		altKeyWasDown = IsAltKeyDown()
		FixSoloQueueButton()
	end
end

-- Only register events when PVPFrame is shown.
local function PVPFrame_Shown()
	altKeyWasDown = IsAltKeyDown()
	if frame then
		frame:Show() -- start OnUpdate polling
	else
		frame = CreateFrame("frame")
		frame:SetScript("OnUpdate", CheckAltOnUpdate)
		frame:SetScript("OnEvent", FixSoloQueueButton)
	end
	frame:RegisterEvent("PARTY_MEMBERS_CHANGED")
	frame:RegisterEvent("RAID_ROSTER_UPDATE")
end

-- Only register events when PVPFrame is shown.
local function PVPFrame_Hidden()
	frame:Hide() -- stop OnUpdate polling
	frame:UnregisterEvent("PARTY_MEMBERS_CHANGED")
	frame:UnregisterEvent("RAID_ROSTER_UPDATE")
end

hooksecurefunc("PVPFrame_TabClicked", FixSoloQueueButton)
FixSoloQueueButton()

PVPFrame:HookScript("OnShow", PVPFrame_Shown)
PVPFrame:HookScript("OnHide", PVPFrame_Hidden)
if PVPFrame:IsShown() then
	PVPFrame_Shown()
end